#include <tchar.h>
#include "mainwin.h"
#include "libjabber/libEBjabber.h"
#include "stun.h"
#include "udp.h"
#include "resource.h"
#include <commctrl.h>
#include <Shellapi.h>
#include "elevation.h"
#include "rdp/rdp.h"

//  jabber
Settings ProgramSettings;
char farSideName[MAX_STRING];
char OpenVPNfarSideName[MAX_STRING];
//  udp
//bool presPort=false;
//bool hairpin=false;

NatType stype; //  NAT
StunAddress4 stunServerAddr;
int fd = 0;	//      
StunAddress4 LocalNatPublicSrcAddrAndPort;
SOCKADDR_IN DestNatPublicAddrAndPort, ExtraDest1, ExtraDest2;
int LocalPort;
int LenSOCKADDR_IN;
bool UDPRecieve, UDPTransmit;
int HoleAttempt;
int NumberOfReconnect = 1;
bool NotConfiged = false;
unsigned char TypeOfScript;
char OVPNbuffer[4096];

HINSTANCE HInstance;
HWND hWnd = NULL;
CHCMDwnd ChCMDwnd[64];
HWND hwndEdit = NULL;

HANDLE LogFileHandle;
extern HANDLE g_hChildStd_IN_Wr[64];
extern JABBER_Conn JabberConnection;
extern LPTSTR ServiceName;  // 
extern HCRYPTPROV hCryptProv;
extern char pChatSender[];   //    jabber
extern BYTE pChatMessage[];	// 
extern HANDLE exit_event;
extern BOOL OpenVPNStarted;
extern WCHAR IPstring[MAX_ADDR];
extern char userHandle[MAX_STRING];
HWND hwndTV;

NOTIFYICONDATA tnd;

int WINAPI WinMain (HINSTANCE hInstance, HINSTANCE hPrevInstance,
                    PSTR szCmdLine, int iCmdShow)
{
	//DebugBreak();
	if(ReadSettings() == -1) NotConfiged = true;
	WCHAR log_path[MAX_PATH];
	swprintf_s(log_path, MAX_PATH, L"%sjabpunch.log", ProgramSettings.PathToFiles);
	LogFileHandle = CreateFile(log_path,    // name of the write
						   FILE_APPEND_DATA,		// open for writing
						   FILE_SHARE_READ | FILE_SHARE_WRITE,         //share
						   NULL,                   // default security
						   OPEN_ALWAYS,          
						   FILE_ATTRIBUTE_NORMAL,  // normal file
						   NULL);                  // no attr. template
	if(LogFileHandle != NULL && GetFileSize(LogFileHandle, NULL) == 0)
	{
		WORD buf = 0xFEFF;  // unicode  
		DWORD result;
		WriteFile (LogFileHandle, &buf, 2, &result, NULL);
	}

//  / ,      
	if (strchr(szCmdLine, 'i'))
	{
		InstallService();
			CloseHandle(LogFileHandle);
		return 0;
	}
	if (strchr(szCmdLine, 'u'))
	{
		RemoveSevice();
		return 0;
	}
	if (strchr(szCmdLine, 'a'))
	{
		RemoveSevice();
		return 0;
	}

	WSADATA wsadata;
	if (WSAStartup(DESIRED_WINSOCK_VERSION, &wsadata) != 0) return -1;
	if (wsadata.wVersion < MINIMUM_WINSOCK_VERSION) return -1;
	wcstombs(farSideName, ProgramSettings.UserHandle, 64);
	char *pRes = strchr(farSideName, '/');
	if (pRes) *pRes = 0;
//	strcpy_s(UserId, 64, ProgramSettings.UserHandle);

	//check for running


	DWORD t;
	if (strchr(szCmdLine, 'r')) t = 60000; //    "r",      60 
	else t = 1000; //     1 

	HANDLE hnd = CreateMutex(NULL, TRUE, ProgramSettings.UserHandle);
	if (GetLastError() == ERROR_ALREADY_EXISTS && WAIT_ABANDONED != WaitForSingleObject(hnd, t))
	{
		CloseHandle(hnd);
		if(ProgramSettings.mode == 0) SetForegroundWindow(FindWindow(NULL, ProgramSettings.UserHandle));
		PrintLog(L"Already running %s", ProgramSettings.UserHandle);
		return -1;
	}

	LenSOCKADDR_IN = sizeof(DestNatPublicAddrAndPort);
	memset(&DestNatPublicAddrAndPort,0,LenSOCKADDR_IN);
	memset(ChCMDwnd, 0, (sizeof(CHCMDwnd)*64));
	memset(g_hChildStd_IN_Wr, 0, (sizeof(HANDLE)*64));
	LocalNatPublicSrcAddrAndPort.addr = 0;
	LocalNatPublicSrcAddrAndPort.port = 0;
	CryptInit();	

	MSG msg;
	if (strchr(szCmdLine, 's'))
	{
		ProgramSettings.mode = 2;
		HInstance = hInstance;
		SERVICE_TABLE_ENTRY DispatcherTable[] =
		{ 
			{
				ServiceName,							// 
				(LPSERVICE_MAIN_FUNCTION)ServiceMain	//  
			}, 
			{ NULL, NULL }
		};

		// 
		if(!StartServiceCtrlDispatcher(DispatcherTable)) return -1;
	}
	else if (strchr(szCmdLine, 'h'))
	{
		ProgramSettings.mode = 1;
		const WCHAR lpcszClassName[] = L"WindowClass";
		WNDCLASSEX  WindowClassEx;
		ZeroMemory(&WindowClassEx, sizeof(WNDCLASSEX));
		WindowClassEx.cbSize        = sizeof(WNDCLASSEX);
		WindowClassEx.lpfnWndProc   = WndServerProc;
		WindowClassEx.hInstance     = hInstance;
		WindowClassEx.lpszClassName = lpcszClassName;

		if (RegisterClassEx(&WindowClassEx) != 0)
		{
			// Create a _MESSAGE ONLY_ window
			hWnd = CreateWindowEx(0, lpcszClassName, NULL, 0, 0, 0, 0, 0, HWND_MESSAGE, NULL, hInstance, NULL);
			if (hWnd == NULL) UnregisterClass(lpcszClassName, hInstance);
		}
		RegisterHotKey(hWnd, 4, MOD_ALT | MOD_CONTROL | MOD_SHIFT, 0x77); // F8
		if(ProgramSettings.DisableSleep) SetThreadExecutionState(ES_CONTINUOUS | ES_SYSTEM_REQUIRED);

		initClient(hWnd);

		while(GetMessage(&msg, NULL, 0, 0) > 0)
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
		return (int)msg.wParam;
	}
	else
	{
		ProgramSettings.mode = 0;
		hWnd = CreateDialog(hInstance, LPCTSTR(IDD_MAIN), 0, WndClientProc);
		HInstance = hInstance;
		//SetMenu(hWnd, LoadMenu(HInstance, MAKEINTRESOURCE(IDR_MENU1)));
		hwndTV = GetDlgItem(hWnd, IDC_TREE1);
		if (!InitTreeViewImageLists(hwndTV))
		{
			DestroyWindow(hwndTV);
	    }
		ShowWindow(hWnd, SW_SHOW);
		UpdateWindow(hWnd);
		ShowWindow(hWnd, SW_SHOWNORMAL);

		//Disable sleep mode
		if(ProgramSettings.DisableSleep) SetThreadExecutionState(ES_CONTINUOUS | ES_SYSTEM_REQUIRED);
		while (GetMessage(&msg, NULL, 0, 0))
		{
			if (msg.message == WM_KEYUP && msg.wParam == VK_RETURN)
				PostMessage(GetParent(msg.hwnd), WM_COMMAND, (WPARAM)IDSEND, 0);
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}
	return 0;
}

bool InitOpenVPNConnection(char * JabUserID)
{
	StopOpenVPNConnection(); //to enshure, that openvpn  stoped on local and remote sides
	HoleAttempt = 0;
	OpenVPNStarted = true;
	strcpy_s(OpenVPNfarSideName, MAX_ADDR, JabUserID);
	AddrMessage Mess;
	Mess.CMDid = STARTNEWSESSION;
	Mess.addr = inet_addr(ProgramSettings.LTunIP);
	IN_ADDR Addrs;
	Addrs.S_un.S_addr = inet_addr(ProgramSettings.LTunIP);
	Addrs.S_un.S_un_b.s_b4 ++;
	if (Addrs.S_un.S_un_b.s_b4 > 254) PrintLog(L"Error in Remote Tunnel IP: %S", inet_ntoa(Addrs));
	wsprintf(IPstring, L"%S %S", ProgramSettings.LTunIP, inet_ntoa(Addrs));
	PostMessage(hWnd, UPDATE_INFO, TUNNEL_IP, NULL);
	sendChatMessage((BYTE *)&Mess,  sizeof(AddrMessage), OpenVPNfarSideName);
	if (stype == StunTypeDependentMapping) StartConnection(STARTCONNECTFixedPorts);
	else  StartConnection(STARTCONNECTFixedPort);
	return true;
}

bool StartConnection(int Typ)
{
	if(GetJabberConnState() != JCONN_STATE_ON)
	{
		SetTimer(hWnd, IDT_RECONNECT, NumberOfReconnect * 5000, (TIMERPROC)NULL);
		PrintLog(L"Disconnected from jabber-server");
		return false;
	}
	if (fd > 0) return false;	
	//  
	OpenVPNStarted = true;
	PostMessage(hWnd, UPDATE_INFO, OPENVPN_STATUS, 1);
	StunAddress4 LocalHostAddrAndPort;
	LocalHostAddrAndPort.addr = 0;
	if (Typ == CONNECTFixedPort || Typ == STARTCONNECTFixedPort || Typ == CONNECTFixedPorts || Typ == STARTCONNECTFixedPorts)
		LocalHostAddrAndPort.port = ProgramSettings.OpenVPNPort;
	else  LocalHostAddrAndPort.port = stunRandomPort();

	for(int i=0; i<3; i++)
	{
		fd = stunOpenSocket( stunServerAddr, &LocalNatPublicSrcAddrAndPort,
			LocalHostAddrAndPort.port, &LocalHostAddrAndPort, false );
		if (fd == -1)
		{
			ErrMessage ErMess;
			ErMess.CMDid = ERROR_MESSAGE;
			strcpy(ErMess.mess, "STUN Error");
			sendChatMessage((BYTE *)&ErMess, strlen(ErMess.mess)+2, OpenVPNfarSideName);
			return false;
		}
		//   STUN   
		if (fd > 0) break;
	}
	if (fd == 0)
	{
		ErrMessage ErMess;
		ErMess.CMDid = ERROR_MESSAGE;
		strcpy(ErMess.mess, "STUN Error");
		sendChatMessage((BYTE *)&ErMess, strlen(ErMess.mess)+2, OpenVPNfarSideName);
		return false;
	}

	LocalPort = LocalHostAddrAndPort.port;

	//        jabber
	AddrMessage Mess;
	Mess.CMDid = Typ;
	Mess.addr = htonl(LocalNatPublicSrcAddrAndPort.addr);
	Mess.port = LocalNatPublicSrcAddrAndPort.port;
	sendChatMessage((BYTE *)&Mess, sizeof(AddrMessage), OpenVPNfarSideName);
	
	SetTimer(hWnd, IDT_RECV_TIMEOUT, 2900, (TIMERPROC)NULL);
	WSAAsyncSelect (fd , hWnd, WSA_NETEVENT, FD_READ);
	if (Typ <= STARTCONNECTRundomPorts)
		PrintLog(L"Send STARTCONNECT to %S: %u.%u.%u.%u:%u",
			OpenVPNfarSideName,
			(*((IN_ADDR *) &(Mess.addr))).s_net,
			(*((IN_ADDR *) &(Mess.addr))).s_host,
			(*((IN_ADDR *) &(Mess.addr))).s_lh,
			(*((IN_ADDR *) &(Mess.addr))).s_impno,
			Mess.port);
	else PrintLog(L"Send CONNECT to %S: %u.%u.%u.%u:%u",
			OpenVPNfarSideName,
			(*((IN_ADDR *) &(Mess.addr))).s_net,
			(*((IN_ADDR *) &(Mess.addr))).s_host,
			(*((IN_ADDR *) &(Mess.addr))).s_lh,
			(*((IN_ADDR *) &(Mess.addr))).s_impno,
			Mess.port);
	return true;
}

void SendPackets()
{
	if(sendto(fd, "Packet1  ", 10, 0, (sockaddr*)&DestNatPublicAddrAndPort, LenSOCKADDR_IN) == SOCKET_ERROR)
	{
		PrintLog(L"ERROR sendto %d.", WSAGetLastError());
	}
	if (TypeOfScript == STARTCONNECTFixedPorts ||
		TypeOfScript == STARTCONNECTRundomPorts ||
		TypeOfScript == CONNECTFixedPorts ||
		TypeOfScript == CONNECTRundomPorts)
	{		//Sending additional packets on incremented ports
		if(sendto(fd, "Packet2  ", 10, 0, (sockaddr*)&ExtraDest1, LenSOCKADDR_IN) == SOCKET_ERROR)
		{
			PrintLog(L"ERROR sendto %d.", WSAGetLastError());
		}
		if(sendto(fd, "Packet3  ", 10, 0, (sockaddr*)&ExtraDest2, LenSOCKADDR_IN) == SOCKET_ERROR)
		{
			PrintLog(L"ERROR sendto %d.", WSAGetLastError());
		}
	}
}

void StopHoleAtempt()
{
	UDPRecieve = false;
	UDPTransmit = false;
	KillTimer(hWnd, IDT_SEND_PACKET);
	KillTimer(hWnd, IDT_RECV_TIMEOUT);
	WSAAsyncSelect (fd , hWnd, 0, 0);
	closesocket(fd);
	fd = 0;
}

void StopOpenVPNConnection()
{
	StopHoleAtempt();
	if(exit_event) SetEvent(exit_event);
	PrintLog(L"Stoping OpenVPN and udp-connections");
	int i = 10;
	while(FindWindow(NULL, L"jpOpenVPN") && i != 0)
	{
		Sleep(100);
		i--;
	}
	OpenVPNStarted = false;
	PostMessage(hWnd, UPDATE_INFO, OPENVPN_STATUS, 0);
}

void StopTunnelConnection()
{

}
void initClient(HWND hwnd)
{
 	exit_event = CreateEvent (NULL, true, false, L"exit-event");
	//Search for proccess with Title = "jpOpenVPN"
	if(FindWindow(NULL, L"jpOpenVPN"))
	{
		PrintLog(L"Found OpenVPN, running by previous start of jabpunch.");
/*		if(GetLastError() == ERROR_ALREADY_EXISTS) SetEvent(exit_event);
		CloseHandle(exit_event);
		exit_event = NULL;
*/	}
	SetTimer(hWnd, IDT_RECONNECT, NumberOfReconnect * 5000, (TIMERPROC)NULL);

	if (!CreateThread (NULL, 0, (LPTHREAD_START_ROUTINE)loginJabber, NULL, 0, NULL))
	{
		PrintLog(L"Error when start loginJabber");
	}

}

void PrintLog(const WCHAR * szFormat, ...)
{
	int cch;
	WCHAR szBuf[4500];
	va_list arglist;

	va_start(arglist, szFormat);
	cch = _vsnwprintf(szBuf, 4500, szFormat, arglist);
	va_end(arglist);

	if ((cch == -1) || (cch == MAX_STRING))
	{
		// overflow
		szBuf[4499] = '\0';
		cch = 4500;
	}

	if (cch > 0)
	{
		// add an end of line
		WCHAR buffer[5100];
		SYSTEMTIME t;
		DWORD dwResult;		
		GetLocalTime(&t);
		swprintf_s(buffer, 5100, L"%d.%d.%d %d:%d:%d,%d ",
			t.wDay, t.wMonth, t.wYear, t.wHour, t.wMinute, t.wSecond, t.wMilliseconds);
		wcscat_s(buffer, 5100, szBuf);
		wcscat_s(buffer, 5100, L"\r\n");
		if(!ProgramSettings.mode)
		{
			int ndx = GetWindowTextLength (hwndEdit);
//			SetFocus (hwndEdit);
			SendMessage (hwndEdit, EM_SETSEL, (WPARAM)ndx, (LPARAM)ndx);
			SendMessage(hwndEdit, EM_REPLACESEL, NULL,(LPARAM)buffer);
		}
		if(LogFileHandle != NULL)
			WriteFile (LogFileHandle, buffer, wcslen(buffer) * sizeof(WCHAR), &dwResult, NULL);
	}
}

LRESULT OnRightTrayClick()
{
	POINT pt;
	HMENU hTrayMenu, hpopup;

	GetCursorPos(&pt);
	hTrayMenu = LoadMenu(GetModuleHandle(NULL), MAKEINTRESOURCE(IDR_TRAY));
	hpopup = GetSubMenu(hTrayMenu, 0);
	SetForegroundWindow(hWnd);
	//hMainMenu = GetMenu(m_hWnd);


	TrackPopupMenu(hpopup,  // Popup menu to track
							// Return menu code
			TPM_RIGHTBUTTON,		// Track right mouse button?
			pt.x, pt.y,				// screen coordinates
			0,						// reserved
			hWnd,					// owner
			NULL);

	DestroyMenu(hTrayMenu); // Delete loaded menu and reclaim its resources
	return 0;
}

BOOL OnJabberCommand(HWND hwnd, WPARAM wParam, LPARAM lParam)
{
	unsigned short i;
	DWORD dwWritten;
	switch (((AddrMessage *)pChatMessage)->CMDid)
	{
		case STARTCONNECTRundomPort:
		case STARTCONNECTFixedPort:
		case STARTCONNECTFixedPorts:
		case STARTCONNECTRundomPorts:
		{
			strcpy_s(OpenVPNfarSideName, MAX_STRING, pChatSender);
			DestNatPublicAddrAndPort.sin_family = AF_INET;
			i = ((AddrMessage *)pChatMessage)->port;
			DestNatPublicAddrAndPort.sin_port = htons(i);
			DestNatPublicAddrAndPort.sin_addr.s_addr = ((AddrMessage *)pChatMessage)->addr;
			TypeOfScript = ((AddrMessage *)pChatMessage)->CMDid;

			if (stype == StunTypeDependentMapping && TypeOfScript <= STARTCONNECTRundomPort)
				// On this side Symmetric NAT, changing TypeOfScript
				TypeOfScript = TypeOfScript + 2;

			PrintLog(L"Recieve STARTCONNECT from %S: %u.%u.%u.%u:%u",
				pChatSender,
				DestNatPublicAddrAndPort.sin_addr.s_net,
				DestNatPublicAddrAndPort.sin_addr.s_host,
				DestNatPublicAddrAndPort.sin_addr.s_lh,
				DestNatPublicAddrAndPort.sin_addr.s_impno,
				i);

			if(StartConnection(TypeOfScript + 4))
			{
				memcpy(&ExtraDest1, &DestNatPublicAddrAndPort, sizeof(SOCKADDR_IN));
				ExtraDest1.sin_port = htons(i + 1);
				memcpy(&ExtraDest2, &DestNatPublicAddrAndPort, sizeof(SOCKADDR_IN));
				ExtraDest2.sin_port = htons(i + 2);
				SetTimer(hWnd, IDT_SEND_PACKET, 1000, (TIMERPROC)NULL); //   ,    1
				SendPackets();
			}
		}
		break;

		case CONNECTRundomPort:
		case CONNECTFixedPort:
		case CONNECTFixedPorts:
		case CONNECTRundomPorts:
			//      
			DestNatPublicAddrAndPort.sin_family = AF_INET;
			i = ((AddrMessage *)pChatMessage)->port;
			DestNatPublicAddrAndPort.sin_port = htons(i);
			DestNatPublicAddrAndPort.sin_addr.s_addr = ((AddrMessage *)pChatMessage)->addr;
			TypeOfScript = ((AddrMessage *)pChatMessage)->CMDid;
			SetTimer(hWnd, IDT_SEND_PACKET, 400, (TIMERPROC)NULL); //    0.4 
			PrintLog(L"Recieve CONNECT from %S: %u.%u.%u.%u:%u",
				pChatSender,
				DestNatPublicAddrAndPort.sin_addr.s_net,
				DestNatPublicAddrAndPort.sin_addr.s_host,
				DestNatPublicAddrAndPort.sin_addr.s_lh,
				DestNatPublicAddrAndPort.sin_addr.s_impno,
				htons(DestNatPublicAddrAndPort.sin_port));

		break;

		case RECEIVED:
			KillTimer(hwnd, IDT_SEND_PACKET);
			KillTimer(hwnd, IDT_RECV_TIMEOUT);
			if (!UDPTransmit && UDPRecieve) //  
			{
				WSAAsyncSelect (fd , hwnd, 0, 0);
				closesocket(fd);
				fd = 0;
				if (!CreateThread (NULL, 0, (LPTHREAD_START_ROUTINE)StartOpenVPN, NULL, 0, NULL))
					PrintLog(L"Start OpenVPN failure");
			}
			UDPTransmit = true;
			PrintLog(L"Recieve CONFIRM from %S", pChatSender);
		break;

		case DISCONNECT:
			PrintLog(L"Recieve DISCONNECT from %S", pChatSender);
			StopOpenVPNConnection();
		break;

		case STARTNEWSESSION:
			StopOpenVPNConnection();
			IN_ADDR Local, Remote;
			char SRemote[64];
			Remote.s_addr = ((AddrMessage *)pChatMessage)->addr;
			strcpy(SRemote, inet_ntoa(Remote));
			Local.s_addr = Remote.s_addr;
			Local.s_impno ++;
			char SLocal[64];
			strcpy(SLocal, inet_ntoa(Local));
			PrintLog(L"Recieve STARTNEWSESSION from %S. Tunnel local IP %S, remote IP %S", pChatSender, SLocal, SRemote);
			if (Local.S_un.S_un_b.s_b4 < 1) PrintLog(L"Error in Local Tunnel IP: %S", SLocal);
			wsprintf(IPstring, L"%S %S", SLocal, SRemote);
			PostMessage(hWnd, UPDATE_INFO, TUNNEL_IP, NULL);

		break;
		

		case INSTALLTAP:
			PrintLog(L"Recieve INSTALLTAP from %S", pChatSender);
			TAPInstall(true);
		break;

		case UNINSTALLTAP:
			PrintLog(L"Recieve UNINSTALLTAP from %S", pChatSender);
			TAPInstall(false);
		break;

//		case TEST:
//			KillTimer(hwnd, IDT_RECONNECT2);
//		break;

		case EXECUTE:
		{
			PrintLog(L"Recieve EXECUTE from %S", pChatSender);
			CommandStruct *param = (CommandStruct *)malloc(sizeof(CommandStruct));
			ZeroMemory(param, sizeof(CommandStruct));
			param->WindowID = ((ExeMessage *)pChatMessage)->HwndID;
			wcsncpy(param->command_line, L"cmd", 256);
			strncpy(param->sender, pChatSender, MAX_ADDR);
			if (!CreateThread (NULL, 0, (LPTHREAD_START_ROUTINE)startexe, param, 0, NULL))
			{
				PrintLog(L"startexe failure");
				free(param);
			}
		}
		break;

		case INPUTMESS:
		{
			i = ((ExeMessage *)pChatMessage)->ThreadID;
			if (!WriteFile(g_hChildStd_IN_Wr[i],
				((ExeMessage *)pChatMessage)->exeMess,
				(lParam - 3), &dwWritten, NULL))
			{
				if (!CloseHandle(g_hChildStd_IN_Wr[i]))	PrintLog(L"StdInWr CloseHandle");
				g_hChildStd_IN_Wr[i] = NULL;
			}
		}
		break;

		case STOPEXECUTE:
		{
			PrintLog(L"Recieve STOPEXECUTE from %S", pChatSender);
			i = ((ExeMessage *)pChatMessage)->ThreadID;
			if (!CloseHandle(g_hChildStd_IN_Wr[i]))
				PrintLog(L"STOPEXECUTE already stopped");
			g_hChildStd_IN_Wr [((ExeMessage *)pChatMessage)->ThreadID] = NULL;
		}
		break;

		case LOG:
		{
			HWND hwndEdit;
			int i = ((ExeMessage *)pChatMessage)->HwndID;
			ChCMDwnd[i].ThreadID = ((ExeMessage *)pChatMessage)->ThreadID;
			if (ChCMDwnd[i].hwnd != NULL)
			{
				hwndEdit = GetDlgItem(ChCMDwnd[i].hwnd, IDC_OUTPUTCMD);
				if(lParam > 3) //len of pChatMessage
				{
					if (lParam < 65535)
					{
						pChatMessage[lParam] = 0;
						pChatMessage[lParam+1] = 0;
					}
					else
					{
						pChatMessage[65534] = 0;
						pChatMessage[65535] = 0;
					}
					int ndx = GetWindowTextLength (hwndEdit);
					SendMessage (hwndEdit, EM_SETSEL, (WPARAM)ndx, (LPARAM)ndx);
					SendMessage(hwndEdit, EM_REPLACESEL, NULL,(LPARAM)(((ExeMessage *)pChatMessage)->exeMess));
					SetFocus (GetDlgItem(ChCMDwnd[i].hwnd, IDC_INPUTCMD));
				}
			}
		}
		break;

		case ENDLOG:
		{
			int i = ((ExeMessage *)pChatMessage)->HwndID;		
			PrintLog(L"Recieve ENDLOG for %d window from %S", i, pChatSender);
			if(ChCMDwnd[i].hwnd != NULL)
			{
				DestroyWindow(ChCMDwnd[i].hwnd);
				memset(&ChCMDwnd[i], 0, sizeof(CHCMDwnd));
			}
		}
		break;

		case RESTART_PROGRAM:
			PrintLog(L"Recieve RESTART_PROGRAM from %S", pChatSender);
			PostMessage(hwnd, WM_COMMAND, IDC_RESTART_PROGRAM, 0);
		break;

		case RESTART_WIN:
			PrintLog(L"Recieve RESTART_WIN from %S", pChatSender);
			StartProgram(L"shutdown", L"\/r \/f", false);
		break;

		case QUERY_PRIVILAGES:
			if(ProgramSettings.mode != 2)
			{
				WCHAR exe_path[MAX_PATH];
				GetModuleFileName(NULL, exe_path, MAX_PATH);
				if(ProgramSettings.mode == 1) StartProgram(exe_path, L" -r -h", true);
				if(ProgramSettings.mode == 0) StartProgram(exe_path, L" -r", true);
				PostMessage(hwnd, WM_CLOSE, 0, 0);
			}
		break;

		case RAINVITESTRING:
		{
			PrintLog(L"Recieve RAINVITESTRING from %S", pChatSender);
			//  invite-
			if (lParam < 65535)
			{
				pChatMessage[lParam] = 0;
				pChatMessage[lParam+1] = 0;
			}
			else
			{
				pChatMessage[65534] = 0;
				pChatMessage[65535] = 0;
			}
			WCHAR * invstr = (WCHAR *)(pChatMessage+1);
			StartRAClient(invstr);
		}
		break;

		case STARTRA:
			PrintLog(L"Recieve STARTRA from %S", pChatSender);
			CreateRAServer(pChatSender);
		break;

		case ERROR_MESSAGE:
			PrintLog(L"Recieve from %S: %S", pChatSender, pChatMessage+1);
		break;

	}
	return FALSE;
}

BOOL OnCommand(HWND hwnd, WPARAM wParam, LPARAM lParam)
{
//	int i;
	switch (wParam)
	{
		case JABBER_ERROR:
			PrintLog(L"%S", lParam);
		break;

		case JABBER_POST_MESSAGE: //  
			//  
			if (strstr(pChatSender, farSideName) == pChatSender && strcmp(pChatSender, userHandle) != 0)
				OnJabberCommand(hwnd, wParam, lParam);
		break;

		case ID_EXIT:
			KillTimer(hwnd, IDT_SEND_PACKET);
			KillTimer(hwnd, IDT_RECV_TIMEOUT);
			WSAAsyncSelect (fd , hwnd, 0, 0);
			PostMessage(hwnd, WM_CLOSE, 0, 0);
		break;

		case ID_SETTINGS:
			DialogBox(HInstance, LPCTSTR(IDD_PAGE2), hwnd, WndSettingsProc);
		break;

		case IDC_INSTALL:
			TAPInstall(true);
		break;

		case IDC_REMOVE:
			TAPInstall(false);
		break;

		case IDC_RESTART_PROGRAM:
			if(ProgramSettings.mode == 2)
//				StartProgram(L"cmd /C net stop \"JabPunch\" && net start \"JabPunch\"");
			{
				for(int i=0; i<64; i++)
				{
					if(g_hChildStd_IN_Wr[i] != NULL)
					{
						CloseHandle(g_hChildStd_IN_Wr[i]);
						Sleep(100);
					}
				}
				StopOpenVPNConnection();
				CryptCleanUp();
				logoutJabber();
				WSACleanup();
				CloseHandle(LogFileHandle);	
				ExitProcess(1);
			}
			else
			{
				WCHAR exe_path[MAX_PATH];
				GetModuleFileName(NULL, exe_path, MAX_PATH);
				if(ProgramSettings.mode == 1) StartProgram(exe_path, L" -r -h", false);
				if(ProgramSettings.mode == 0) StartProgram(exe_path, L" -r", false);
				PostMessage(hwnd, WM_CLOSE, 0, 0);
			}
		break;

		case IDC_RINSTALL:
		{
			BOOL fIsRunAsAdmin = false;		
			try
			{
				fIsRunAsAdmin = IsRunAsAdmin();
			}
			catch (DWORD dwError)
			{
				PrintLog(L"Error when IsRunAsAdmin", dwError);
			}
			if (!fIsRunAsAdmin)
			{
				WCHAR exe_path[MAX_PATH];
				GetModuleFileName(NULL, exe_path, MAX_PATH);
				StartProgram(exe_path, L" -i", true);
			}
			else InstallService();
		}			
		break;

		case IDC_RREMOVE:
		{
			BOOL fIsRunAsAdmin = false;		
			try
			{
				fIsRunAsAdmin = IsRunAsAdmin();
			}
			catch (DWORD dwError)
			{
				PrintLog(L"Error when IsRunAsAdmin", dwError);
			}
			if (!fIsRunAsAdmin)
			{
				WCHAR exe_path[MAX_PATH];
				GetModuleFileName(NULL, exe_path, MAX_PATH);
				StartProgram(exe_path, L" -u", true);
			}
			else RemoveSevice();
		}
		break;
	}
	return true;
}

BOOL OnUpadateInfo(HWND hwnd, WPARAM wParam, LPARAM lParam)
{
	WCHAR line[MAX_STRING];

	switch (wParam)
	{
	case NAT_TYPE:
		Edit_SetText(GetDlgItem(hwnd, IDC_NAT_TYPE), (WCHAR *)lParam);
		break;

	case PUBLIC_IP:
		{
			IN_ADDR Addrs;
			Addrs.s_addr = htonl(lParam);
			mbstowcs(line, inet_ntoa(Addrs), MAX_STRING);
			Edit_SetText(GetDlgItem(hwnd, IDC_NAT_IP), line);
		}
		break;

	case JABBER_STATUS:
		switch (lParam)
		{
		case -1:
			Edit_SetText(GetDlgItem(hwnd, IDC_JABBER_STATUS), L"Error");
			break;
		case 0:
			Edit_SetText(GetDlgItem(hwnd, IDC_JABBER_STATUS), L"Disconnected");
			break;
		case 1:
			Edit_SetText(GetDlgItem(hwnd, IDC_JABBER_STATUS), L"Connecting");
			break;
		case 2:
		case 3:
			Edit_SetText(GetDlgItem(hwnd, IDC_JABBER_STATUS), L"Connected");
			break;
		}
		break;

	case OPENVPN_STATUS:
//		Edit_SetText(GetDlgItem(hwnd, IDC_OPENVPN_STATUS), line);
		switch (lParam)
		{
		case 0:
			Edit_SetText(GetDlgItem(hwnd, IDC_OPENVPN_STATUS), L"Stopped");
			break;
		case 1:
			Edit_SetText(GetDlgItem(hwnd, IDC_OPENVPN_STATUS), L"Preparing Connection");
			break;
		case 2:
			Edit_SetText(GetDlgItem(hwnd, IDC_OPENVPN_STATUS), L"Retrying");
			break;
		case 3:
			Edit_SetText(GetDlgItem(hwnd, IDC_OPENVPN_STATUS), L"Starting OpenVPN");
			break;
		case 4:
			Edit_SetText(GetDlgItem(hwnd, IDC_OPENVPN_STATUS), L"OpenVPN Connected");
			break;
		}
		break;

	case TUNNEL_IP:
		{
			WCHAR LocalIP[MAX_ADDR];
			wcscpy(LocalIP, IPstring);
			WCHAR * RemoteIP = wcschr(LocalIP, L' ') + 1;
			LocalIP[RemoteIP-LocalIP-1] = L'\0';
			Edit_SetText(GetDlgItem(hwnd, IDC_LOCAL_IP), LocalIP);
			Edit_SetText(GetDlgItem(hwnd, IDC_REMOTE_IP), RemoteIP);
		}
		break;
	}
	return true;
}

BOOL CALLBACK WndClientProc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
//	BYTE cmd;
	switch (message)
	{
		case WM_INITDIALOG:
		{
			tnd.cbSize = sizeof(NOTIFYICONDATA);
			tnd.hWnd = hwnd;
			tnd.uID = IDI_OPENVPN;
			tnd.uFlags = NIF_MESSAGE|NIF_ICON|NIF_TIP;
			tnd.uCallbackMessage = ID_TRAY;
			tnd.hIcon = LoadIcon(GetModuleHandle(NULL), MAKEINTRESOURCE(IDI_OPENVPN));
			wcsncpy_s(tnd.szTip, 64, L"JabPunch", 8);
			Shell_NotifyIcon(NIM_ADD,&tnd);
			hWnd = hwnd;
			hwndEdit = GetDlgItem(hwnd, IDC_EDIT1);
			Edit_LimitText(hwndEdit, 10240000);
			if (NotConfiged)
				PostMessage(hwnd, WM_COMMAND, ID_SETTINGS, 0);
			else 
			{
				initClient(hwnd);
				PostMessage(hWnd, UPDATE_INFO, NAT_TYPE, (LPARAM)L"Evaluating");
			}
		}
		break;

		case ID_TRAY:
			switch (lParam)
			{
				case WM_LBUTTONDBLCLK:
					if(IsWindowVisible(hwnd))	ShowWindow(hwnd, SW_HIDE);
					else ShowWindow(hwnd, SW_SHOWNORMAL);
					break;
				case WM_RBUTTONUP:
					OnRightTrayClick();
					break;
			}
		case WM_TIMER:
			switch (wParam)
			{
				case IDT_REFRESH_CONNECTION:
					if(GetJabberConnState())
					{
						PrintLog(L"Update connection");
						NumberOfReconnect = 2;
						//SetTimer(hWnd, IDT_RECONNECT2, 10000, (TIMERPROC)NULL);
						//refreshRoster();
						testPresence();
					}
					else
					{
						PostMessage(hWnd, UPDATE_INFO, JABBER_STATUS, 0);
						PrintLog(L"Jabber connection broken");
					}
				break;

//				case IDT_RECONNECT2:
//					KillTimer(hwnd, IDT_RECONNECT2);
//					logoutJabber();
				// WithOUT break;

				case IDT_RECONNECT:
					if(GetJabberConnState())
					{
						NumberOfReconnect = 1;
						KillTimer(hwnd, IDT_RECONNECT);
						SetTimer(hWnd, IDT_REFRESH_CONNECTION,
							ProgramSettings.jabberUpdateTime * 1000,
							(TIMERPROC)NULL);
//						PostMessage(hWnd, UPDATE_INFO, JABBER_STATUS, 2);
					}
					else
					{
						if (NumberOfReconnect < 12) NumberOfReconnect ++;
						SetTimer(hWnd, IDT_RECONNECT, NumberOfReconnect * 5000, (TIMERPROC)NULL);
						if (!CreateThread (NULL, 0, (LPTHREAD_START_ROUTINE)loginJabber, NULL, 0, NULL))
						{
							PrintLog(L"Error when start loginJabber");
							return FALSE;
						}
					}
				break;

				case IDT_SEND_PACKET:
					if (!UDPTransmit)
					{
						SetTimer(hWnd, IDT_SEND_PACKET, 1000, (TIMERPROC)NULL);
						SendPackets();
					}
				break;

				case IDT_RECV_TIMEOUT:
					PrintLog(L"TIMEOUT");
					StopOpenVPNConnection();
					Sleep(100);
					if(TypeOfScript == STARTCONNECTFixedPort) StartConnection(STARTCONNECTRundomPort);
					else if(TypeOfScript == STARTCONNECTRundomPort) StartConnection(STARTCONNECTFixedPorts);
					else if(TypeOfScript == STARTCONNECTFixedPorts) StartConnection(STARTCONNECTRundomPorts);
					else if(TypeOfScript == STARTCONNECTRundomPorts) StartConnection(STARTCONNECTFixedPort);
				break;
			}
		break;

		case WM_COMMAND:
			OnCommand(hwnd, wParam, lParam);
		break;

		case MESSAGE_NOTIFY:
			//if (DISPID_RDPSRAPI_EVENT_ON_ATTENDEE_DISCONNECTED == wParam) StopRAServer();
		break;

		case UPDATE_INFO:
			OnUpadateInfo(hwnd, wParam, lParam);
		break;

		case WSA_NETEVENT: //    ,   jabber
		{
			if(!fd) return false;
			SOCKADDR_IN addr;
			int nAddrSize= sizeof(addr);
			char szTemp[256];
			int rc = recvfrom(fd, szTemp, 256, 0, (PSOCKADDR  )&addr, &nAddrSize);
			if(rc == SOCKET_ERROR)
			{
				rc = WSAGetLastError();
				PrintLog(L"CLIENT ERROR recvfrom %d. From %s:%u", rc, inet_ntoa(addr.sin_addr), htons(addr.sin_port));
			}
			else if(rc > 0 &&strstr(szTemp, "Packet") == szTemp && !UDPRecieve)
			{
				//    ,     
				szTemp[rc] = '\0';
				DestNatPublicAddrAndPort.sin_family = AF_INET;
				DestNatPublicAddrAndPort.sin_addr.s_addr = addr.sin_addr.s_addr;
				DestNatPublicAddrAndPort.sin_port = addr.sin_port;
				PrintLog(L"RECEIVED from %S:%u %S", inet_ntoa(addr.sin_addr), htons(addr.sin_port), szTemp);
				
				
				AddrMessage Mess;
				Mess.CMDid = RECEIVED;
				Mess.addr = htonl(LocalNatPublicSrcAddrAndPort.addr);
				Mess.port = LocalNatPublicSrcAddrAndPort.port;
				sendChatMessage((BYTE *)&Mess, sizeof(AddrMessage), OpenVPNfarSideName);
				if (UDPTransmit)
				{
				//     . ,   openvpn
					WSAAsyncSelect (fd , hwnd, 0, 0);
					closesocket(fd);
					fd = 0;
					if (!CreateThread (NULL, 0, (LPTHREAD_START_ROUTINE)StartOpenVPN, NULL, 0, NULL))
						PrintLog(L"Start OpenVPN failure");
				}
				UDPRecieve = true;
			}
		}
		break;

        case WM_NOTIFY:
			if (wParam == IDC_TREE1) TV_NotifyHandler(hWnd, message, wParam, lParam);
        break;

		case WM_SYSCOMMAND:
			if (wParam == SC_MINIMIZE)
			{
				ShowWindow( hWnd, SW_HIDE);
				return 1;
			}
		break;

		case WM_POWERBROADCAST:
			if (wParam == PBT_APMSUSPEND)
			{
				PrintLog(L"APMSUSPEND start logout");
				logoutJabber();
			}
			if (wParam == PBT_APMRESUMEAUTOMATIC)
			{
				SetTimer(hWnd, IDT_RECONNECT, NumberOfReconnect * 5000, (TIMERPROC)NULL);
				if (!CreateThread (NULL, 0, (LPTHREAD_START_ROUTINE)loginJabber, NULL, 0, NULL))
				{
					PrintLog(L"Error when start loginJabber");
					return FALSE;
				}
			}
			break;

		case WM_CLOSE: //     -  .
			for(int i=0; i<64; i++)
			{
				if(ChCMDwnd[i].hwnd != NULL) SendMessage(ChCMDwnd[i].hwnd, WM_CLOSE, 0, 0);
				if(g_hChildStd_IN_Wr[i] != NULL)
				{
					CloseHandle(g_hChildStd_IN_Wr[i]);
					Sleep(100);
				}
			}			
			StopOpenVPNConnection();
			logoutJabber();
			Shell_NotifyIcon(NIM_DELETE,&tnd);
			CryptCleanUp();
			WSACleanup();
			CloseHandle(LogFileHandle);
			DestroyWindow(hWnd);
			PostQuitMessage(0);
		break;
	}
	return false;
}

LRESULT CALLBACK WndServerProc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
		case WM_TIMER:
		{
			switch (wParam)
			{
				case IDT_REFRESH_CONNECTION:
					if(GetJabberConnState())
					{
						NumberOfReconnect = 2;
						testPresence();
						PrintLog(L"Update connection");
					}
					else
					{
						PrintLog(L"Jabber connection broken");
					}
				break;

				case IDT_RECONNECT:
					if(GetJabberConnState())
					{
						NumberOfReconnect = 1;
						PrintLog(L"Jabber connection established");
						KillTimer(hwnd, IDT_RECONNECT);
						SetTimer(hWnd, IDT_REFRESH_CONNECTION,
							ProgramSettings.jabberUpdateTime * 1000,
							(TIMERPROC)NULL);
					}
					else
					{
						if (NumberOfReconnect < 12) NumberOfReconnect ++;
						SetTimer(hWnd, IDT_RECONNECT, NumberOfReconnect * 5000, (TIMERPROC)NULL);
						loginJabber();
					}
				break;

				case IDT_SEND_PACKET:
					if (!UDPTransmit)//       1 
					{
						SetTimer(hWnd, IDT_SEND_PACKET, 1000, (TIMERPROC)NULL);
						SendPackets();
					}
				break;

				case IDT_RECV_TIMEOUT:
					PrintLog(L"TIMEOUT");
					StopOpenVPNConnection();
					Sleep(100);
					if(TypeOfScript == STARTCONNECTFixedPort) StartConnection(STARTCONNECTRundomPort);
					else if(TypeOfScript == STARTCONNECTRundomPort) StartConnection(STARTCONNECTFixedPorts);
					else if(TypeOfScript == STARTCONNECTFixedPorts) StartConnection(STARTCONNECTRundomPorts);
					else if(TypeOfScript == STARTCONNECTRundomPorts) StartConnection(STARTCONNECTFixedPort);
				break;
			}
		}
		break;

		case WM_HOTKEY:
			if(lParam == 0x00770007)
			{
				PrintLog(L"QUIT Hotkey");
				DestroyWindow(hwnd);
			}
		break;

		case WM_COMMAND:
			OnCommand(hwnd, wParam, lParam);
		break;

		case WSA_NETEVENT: //    ,   jabber
		{
			if(!fd) return false;
			SOCKADDR_IN addr;
			int nAddrSize= sizeof(addr);
//			char Buf[256];
			char szTemp[256];

			int rc = recvfrom(fd, szTemp, 256, 0, (PSOCKADDR  )&addr, &nAddrSize);
			if(rc == SOCKET_ERROR)
			{
				rc = WSAGetLastError();
				PrintLog(L"SERVER: recvfrom error %d. From %s:%u", rc, inet_ntoa(addr.sin_addr), htons(addr.sin_port));
			}

			else if (rc > 0 &&strstr(szTemp, "Packet") == szTemp && !UDPRecieve)
			{
				//    ,     
				szTemp[rc] = '\0';
				DestNatPublicAddrAndPort.sin_family = AF_INET;
				DestNatPublicAddrAndPort.sin_addr.s_addr = addr.sin_addr.s_addr;
				DestNatPublicAddrAndPort.sin_port = addr.sin_port;
				PrintLog(L"RECEIVED from %S:%u %S", inet_ntoa(addr.sin_addr), htons(addr.sin_port), szTemp);
								
				AddrMessage Mess;
				Mess.CMDid = RECEIVED;
				Mess.addr = htonl(LocalNatPublicSrcAddrAndPort.addr);
				Mess.port = LocalNatPublicSrcAddrAndPort.port;
				sendChatMessage((BYTE *)&Mess, sizeof(AddrMessage), OpenVPNfarSideName);
				if (UDPTransmit)
				{
				//     . ,   openvpn
					WSAAsyncSelect (fd , hwnd, 0, 0);
					closesocket(fd);
					fd = 0;
					if (!CreateThread (NULL, 0, (LPTHREAD_START_ROUTINE)StartOpenVPN, NULL, 0, NULL))
						PrintLog(L"Start OpenVPN failure");
				}
				UDPRecieve = true;
			}
		}
		break;

		case WM_POWERBROADCAST:
			if (wParam == PBT_APMSUSPEND)
			{
				PrintLog(L"APMSUSPEND start logout");
				logoutJabber();
			}
			if (wParam == PBT_APMRESUMEAUTOMATIC) 
			{
				SetTimer(hWnd, IDT_RECONNECT, NumberOfReconnect * 5000, (TIMERPROC)NULL);
				loginJabber();
			}
		break;

		case MESSAGE_NOTIFY:
			//if (DISPID_RDPSRAPI_EVENT_ON_ATTENDEE_DISCONNECTED == wParam) StopRAServer();
		break;		

		case WM_CLOSE: //     -  .
			DestroyWindow(hwnd);
		break;

		case WM_DESTROY:
			for(int i=0; i<64; i++)
			{
				if(g_hChildStd_IN_Wr[i] != NULL)
				{
					CloseHandle(g_hChildStd_IN_Wr[i]);
					Sleep(100);
				}
			}
			StopOpenVPNConnection();
			logoutJabber();
			CryptCleanUp();
			WSACleanup();
			CloseHandle(LogFileHandle);
			PostQuitMessage(0);
		break;

		default:
	        return DefWindowProc(hwnd, message, wParam, lParam);
	}
	return 0;
}

