#include <tchar.h>
#include "mainwin.h"
#include "libjabber/libEBjabber.h"
#include "stun.h"

DWORD dwErrCode;                      // 
SERVICE_STATUS ss;                    //  
SERVICE_STATUS_HANDLE ssHandle;       //  

LPTSTR ServiceName = _T("Jabpunch");  // 

extern HWND hWnd;
extern HINSTANCE HInstance;
extern Settings ProgramSettings;
extern StunAddress4 stunServerAddr;
//extern NatType stype;
extern bool presPort;
extern bool hairpin;

//   

void WINAPI ServiceMain(DWORD argc, LPSTR* argv) {
   
   ssHandle = RegisterServiceCtrlHandler(ServiceName, ServiceControl);
   if(!ssHandle) {
//      printf("Error registering ServiceControl\n");
//      _getch();
      return;
   }

   // ,   :
   //    
   ss.dwServiceType = SERVICE_WIN32_OWN_PROCESS | SERVICE_INTERACTIVE_PROCESS;
   //    
   SetServiceStatus(SERVICE_START_PENDING, NO_ERROR, 4000);

   //  CDialer
   InitServiceData();

   //   
   SetServiceStatus(SERVICE_RUNNING, NO_ERROR, 0);

   //  
   initClient(hWnd);
	//SetTimer(hWnd, IDT_RECONNECT, 5000, (TIMERPROC)NULL);
	//loginJabber();

	MSG msg;
	while(GetMessage(&msg, NULL, 0, 0) > 0)
	{
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
   return;
}

BOOL InitServiceData()
{
	const WCHAR lpcszClassName[] = L"WindowClass";
	WNDCLASSEX  WindowClassEx;
	ZeroMemory(&WindowClassEx, sizeof(WNDCLASSEX));
	WindowClassEx.cbSize        = sizeof(WNDCLASSEX);
	WindowClassEx.lpfnWndProc   = WndServerProc;
	WindowClassEx.hInstance     = HInstance;
	WindowClassEx.lpszClassName = lpcszClassName;

	if (RegisterClassEx(&WindowClassEx) != 0)
	{
		// Create a _MESSAGE ONLY_ window
		hWnd = CreateWindowEx(0, lpcszClassName, NULL, 0, 0, 0, 0, 0, HWND_MESSAGE, NULL, HInstance, NULL);
		if (hWnd == NULL) UnregisterClass(lpcszClassName, HInstance);
	}
	

//	stype = stunNatType(stunServerAddr, false, &presPort, &hairpin, 0, 0);

	return true;
}

//---------------------------------------------------------------------------
void StopService()
{
	SendMessage(hWnd, WM_CLOSE, 0, 0);
}

//---------------------------------------------------------------------------
void WINAPI ServiceControl(DWORD dwControlCode) {
   //     
   switch(dwControlCode) {
      //  
      case SERVICE_CONTROL_STOP: {
         //   
         SetServiceStatus(SERVICE_STOP_PENDING, NO_ERROR, 0);

         // 
         StopService();

         //   
         SetServiceStatus(SERVICE_STOPPED, NO_ERROR, 0);
         break;
      }
      //   
      case SERVICE_CONTROL_INTERROGATE: {
         SetServiceStatus(ss.dwCurrentState, NO_ERROR, 0);
         break;
      }
      default: {
         SetServiceStatus(ss.dwCurrentState, NO_ERROR, 0);
         break;
      }
   }
}

//---------------------------------------------------------------------------
void SetServiceStatus(DWORD dwCurrentState,
                           DWORD dwWin32ExitCode,
                           DWORD dwWaitHint)
{
   //   
   static DWORD dwCheckPoint = 1;

   //      ,   
   if(dwCurrentState == SERVICE_START_PENDING)
      ss.dwControlsAccepted = 0;
   else
      ss.dwControlsAccepted = SERVICE_ACCEPT_STOP;

   ss.dwCurrentState = dwCurrentState;
   ss.dwWin32ExitCode = dwWin32ExitCode;
   //   
   ss.dwWaitHint = dwWaitHint;

   //      ,   
   //  
   if(dwCurrentState == SERVICE_RUNNING || dwCurrentState == SERVICE_STOPPED)
      ss.dwCheckPoint = 0;
   else
      ss.dwCheckPoint = dwCheckPoint++;

   //   
   SetServiceStatus(ssHandle, &ss);
}

HRESULT InstallService()
{
	SC_HANDLE hService;            // 
	SC_HANDLE hSCManager;          // Service Control Manager
	WCHAR exe_path[MAX_PATH];
	swprintf_s(exe_path, MAX_PATH, L"%s\jabpunch.exe /s", ProgramSettings.PathToFiles);
	WCHAR message [MAX_PATH+100];
	swprintf_s(message, MAX_PATH+100, L"Create service with current path to exe-file:\n%s?", exe_path);

	if(IDNO == MessageBox(hWnd, message, L"Install service", MB_YESNO | MB_ICONQUESTION))
		return -1;

	// SCM
	hSCManager = OpenSCManager(NULL, NULL, SC_MANAGER_CREATE_SERVICE);
	if(!hSCManager)
	{
		PrintLog(L"Can't open Service Control Manager");
		MessageBox(hWnd, L"Can't open Service Control Manager", L"Error Install service", MB_OK | MB_ICONERROR);
		return -1;
	}

	//  CDialer
	hService = CreateService(hSCManager, L"JabPunch",
					  L"JabPunch", SERVICE_ALL_ACCESS,
					  SERVICE_WIN32_OWN_PROCESS, SERVICE_AUTO_START,
					  SERVICE_ERROR_NORMAL,
					  exe_path, NULL, NULL, NULL, NULL, NULL);
	 if(!hService)
	 {
		GetSvcError();
		CloseServiceHandle(hSCManager);
		return -1;
	 }
	 //
	 SERVICE_FAILURE_ACTIONS sfa;
	SC_ACTION actions;

	sfa.dwResetPeriod = 0;
	sfa.lpCommand = NULL;
	sfa.lpRebootMsg = NULL;
	sfa.cActions = 1;
	sfa.lpsaActions = &actions;

	sfa.lpsaActions[0].Type = SC_ACTION_RESTART;
	sfa.lpsaActions[0].Delay = 5000; 

	ChangeServiceConfig2(hService, SERVICE_CONFIG_FAILURE_ACTIONS, &sfa);

	PrintLog(L"Service Installed successfully. Exe-path: %s", exe_path);
	MessageBox(hWnd, L"Service Installed successfully.", L"Install service", MB_OK);
	 //  
	 CloseServiceHandle(hService);
	 //  SCM
	 CloseServiceHandle(hSCManager);
	 return 0;
}

HRESULT RemoveSevice()
{
	SC_HANDLE hService;            // 
	SC_HANDLE hSCManager;          // Service Control Manager

	hSCManager = OpenSCManager(NULL, NULL, SC_MANAGER_ALL_ACCESS);
	if(!hSCManager)
	{
		PrintLog(L"Can't open Service Control Manager");
		return -1;
	 }
	hService = OpenService(hSCManager, L"JabPunch", SERVICE_STOP | DELETE);
	 if(!hService)
	 {
		GetSvcError();
		return -1;
	 }
	 if(ss.dwCurrentState != SERVICE_STOPPED)
		ControlService(hService, SERVICE_CONTROL_STOP, &ss);
	 //   
	 if (DeleteService(hService) != 0)
	 {
			PrintLog(L"Service Removed successfully");
		 	MessageBox(hWnd, L"Service Removed successfully.", L"Service remove", MB_OK);
	 }
	 else GetSvcError();

	 CloseServiceHandle(hService);
	 CloseServiceHandle(hSCManager);
	 return 0;
}

void GetSvcError()
{
	DWORD dwError = GetLastError();
	switch(dwError)
   {
		case ERROR_ACCESS_DENIED:
			PrintLog(L"The specified service control manager database handle does not have access to the service.");
 			MessageBox(hWnd,
				L"The specified service control manager database handle does not have access to the service.",
				L"Error manage service", MB_OK | MB_ICONERROR);
		break;
      
		case ERROR_INVALID_HANDLE:
			PrintLog(L"The specified handle is invalid.");
			MessageBox(hWnd,
				L"The specified handle is invalid.",
				L"Error manage service", MB_OK | MB_ICONERROR);
		break;

		case ERROR_INVALID_NAME:
			PrintLog(L"The specified service name is invalid.");
			MessageBox(hWnd,
				L"The specified service name is invalid.",
				L"Error manage service", MB_OK | MB_ICONERROR);
		break;

		case ERROR_SERVICE_DOES_NOT_EXIST:
			PrintLog(L"The specified service does not exist.");
			MessageBox(hWnd,
				L"The specified service does not exist.",
				L"Error manage service", MB_OK | MB_ICONERROR);
		break;

		case ERROR_SERVICE_EXISTS:
			PrintLog(L"The specified service already exists.");
			MessageBox(hWnd,
				L"The specified service already exists.",
				L"Error manage service", MB_OK | MB_ICONERROR);
		break;


		case ERROR_SERVICE_MARKED_FOR_DELETE:
			PrintLog(L"The specified service has already been marked for deletion.");
			MessageBox(hWnd,
				L"The specified service has already been marked for deletion.",
				L"Error manage service", MB_OK | MB_ICONERROR);
		break;

		default:
			PrintLog(L"Unknown Error.");
			MessageBox(hWnd,
				L"Unknown Error.",
				L"Error manage service", MB_OK | MB_ICONERROR);

	}
	return;
}