#include "mainwin.h"
#include "resource.h"
#include "libjabber/libEBjabber.h"
#include <commctrl.h>
#include "elevation.h"

extern HINSTANCE HInstance;
extern HWND hWnd;
extern Settings ProgramSettings;

BOOL CALLBACK WndSettingsProc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	WCHAR line[256];

	switch (message)
	{
		case WM_INITDIALOG:
			Edit_SetText(GetDlgItem(hwnd, IDC_CMDPASS), ProgramSettings.CMDPass);
			_itow_s(ProgramSettings.jabberUpdateTime, line, MAX_STRING, 10);
			Edit_SetText(GetDlgItem(hwnd, IDC_JABBERUPDATETIME), line);
			_itow_s(ProgramSettings.OpenVPNPort, line, MAX_STRING, 10);
			Edit_SetText(GetDlgItem(hwnd, IDC_OPENVPNPORT), line);
			mbstowcs(line, ProgramSettings.LTunIP, 64);
			Edit_SetText(GetDlgItem(hwnd, IDC_LTunIP), line);
			Edit_SetText(GetDlgItem(hwnd, IDC_USER), ProgramSettings.UserHandle);
			Edit_SetText(GetDlgItem(hwnd, IDC_PASS), ProgramSettings.Pass);
			Edit_SetText(GetDlgItem(hwnd, IDC_STUN), ProgramSettings.StunAddr);
			Edit_SetText(GetDlgItem(hwnd, IDC_OPENVPN), ProgramSettings.OpenVPNStartString);
			if(ProgramSettings.DisableSleep)
				Button_SetCheck(GetDlgItem(hwnd, IDC_DISABLESLEEP), BST_CHECKED);
			break;

		case WM_COMMAND:
			switch (wParam)
			{
				case IDC_INSTALL:
					TAPInstall(true);
				break;

				case IDC_REMOVE:
					TAPInstall(false);
				break;

				case IDC_RINSTALL:
				{
					BOOL fIsRunAsAdmin = false;		
					try
					{
						fIsRunAsAdmin = IsRunAsAdmin();
					}
					catch (DWORD dwError)
					{
						PrintLog(L"Error when IsRunAsAdmin", dwError);
					}
					if (!fIsRunAsAdmin)
					{
						WCHAR exe_path[MAX_PATH];
						GetModuleFileName(NULL, exe_path, MAX_PATH);
						StartProgram(exe_path, L" -i", true);
					}
					else InstallService();
				}			
				break;

				case IDC_RREMOVE:
				{
					BOOL fIsRunAsAdmin = false;		
					try
					{
						fIsRunAsAdmin = IsRunAsAdmin();
					}
					catch (DWORD dwError)
					{
						PrintLog(L"Error when IsRunAsAdmin", dwError);
					}
					if (!fIsRunAsAdmin)
					{
						WCHAR exe_path[MAX_PATH];
						GetModuleFileName(NULL, exe_path, MAX_PATH);
						StartProgram(exe_path, L" -u", true);
					}
					else RemoveSevice();
				}
				break;

				case IDC_FIREWALL:
				{
					BOOL fIsRunAsAdmin = false;		
					try
					{
						fIsRunAsAdmin = IsRunAsAdmin();
					}
					catch (DWORD dwError)
					{
						PrintLog(L"Error when IsRunAsAdmin", dwError);
					}
					WCHAR exe_path[MAX_PATH];
					GetModuleFileName(NULL, exe_path, MAX_PATH);
					
					OSVERSIONINFO osvi;
					ZeroMemory(&osvi, sizeof(OSVERSIONINFO));
					osvi.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
					GetVersionEx(&osvi);
					WCHAR cmd_line[MAX_PATH];
					if (osvi.dwMajorVersion > 5)
					{
						swprintf_s(cmd_line, MAX_PATH-2,
							L" advfirewall firewall add rule name=\"JabPunch\" dir=in action=allow program=\"%s\" enable=yes",
							exe_path);
						StartProgram(L"netsh", cmd_line, !fIsRunAsAdmin);
						swprintf_s(cmd_line, MAX_PATH-2,
							L" advfirewall firewall add rule name=\"OpenVPN\" dir=in action=allow program=\"%sbin\\openvpn.exe\" enable=yes",
							ProgramSettings.PathToFiles);
						StartProgram(L"netsh", cmd_line, !fIsRunAsAdmin);
					}
					else if((osvi.dwMajorVersion == 5) && (osvi.dwMinorVersion >= 1))
					{
						swprintf_s(cmd_line, MAX_PATH-2,
							L" firewall add allowedprogram \"%s\" \"JabPunch\" ENABLE",
							exe_path);
						StartProgram(L"netsh", cmd_line, !fIsRunAsAdmin);
						swprintf_s(cmd_line, MAX_PATH-2,
							L" firewall add allowedprogram \"%sbin\\openvpn.exe\" \"OpenVPN\" ENABLE",
							ProgramSettings.PathToFiles);
						StartProgram(L"netsh", cmd_line, !fIsRunAsAdmin);
					}
				}
				break;

				case IDC_OK:
					Edit_GetText(GetDlgItem(hwnd, IDC_CMDPASS), ProgramSettings.CMDPass, MAX_STRING);
					Edit_GetText(GetDlgItem(hwnd, IDC_JABBERUPDATETIME), line, MAX_STRING);
					ProgramSettings.jabberUpdateTime  = _wtoi(line);
					Edit_GetText(GetDlgItem(hwnd, IDC_OPENVPNPORT), line, MAX_STRING);
					ProgramSettings.OpenVPNPort  = _wtoi(line);
					Edit_GetText(GetDlgItem(hwnd, IDC_LTunIP), line, MAX_STRING);
					wcstombs(ProgramSettings.LTunIP, line, 64);
					Edit_GetText(GetDlgItem(hwnd, IDC_USER), ProgramSettings.UserHandle, MAX_STRING);
					Edit_GetText(GetDlgItem(hwnd, IDC_PASS), ProgramSettings.Pass, MAX_STRING);
					Edit_GetText(GetDlgItem(hwnd, IDC_STUN), ProgramSettings.StunAddr, MAX_STRING);
					Edit_GetText(GetDlgItem(hwnd, IDC_OPENVPN), ProgramSettings.OpenVPNStartString, MAX_STRING);
					if (Button_GetState(GetDlgItem(hwnd, IDC_DISABLESLEEP)) == BST_CHECKED)
					{
						ProgramSettings.DisableSleep = true;
						SetThreadExecutionState(ES_CONTINUOUS | ES_SYSTEM_REQUIRED);
					}
					else 
					{
						ProgramSettings.DisableSleep = false;
						SetThreadExecutionState(ES_CONTINUOUS);
					}
					WriteSettings();
					PrintLog(L"Settings Saved. Restarting connections");
					StopOpenVPNConnection();
					logoutJabber();
					// Jabber-  5 
					//SetTimer(hWnd, IDT_RECONNECT, 5000, (TIMERPROC)NULL);
				//   break
				case IDC_CANCEL: 
                    EndDialog(hwnd, wParam); 
                return TRUE; 
			}
		break;

		case WM_CLOSE: //     -  .
			EndDialog(hwnd, wParam);
		break;
	}
	return false;
}

int ReadSettings()
{
	WCHAR buffer[MAX_PATH];
	WCHAR line[256];
	WCHAR drive[_MAX_DRIVE];
	WCHAR dir[_MAX_DIR];
	WCHAR fname[_MAX_FNAME];
	int ret = 0;
	GetModuleFileName(NULL,buffer,MAX_PATH); 
   _wsplitpath(buffer, drive, dir, fname, NULL);
   _wmakepath(ProgramSettings.PathToFiles, drive, dir, NULL, NULL);
   _wmakepath(buffer, drive, dir, fname, L"ini");
	
	if(!GetPrivateProfileString(L"settings", L"mode", NULL, line, 10, buffer))
		ProgramSettings.mode = 0;
	else
	{
		if(wcscmp(line , L"service") == 0) ProgramSettings.mode = 2;
		else if(wcscmp(line , L"hidden") == 0) ProgramSettings.mode = 1;
		else ProgramSettings.mode = 0;
	}

	if(!GetPrivateProfileString(L"settings", L"jabberUpdateTime", NULL, line, MAX_ADDR, buffer))
		ProgramSettings.jabberUpdateTime = 1800;
	else ProgramSettings.jabberUpdateTime = _wtoi(line);

	if(!GetPrivateProfileString(L"settings", L"OpenVPNPort", NULL, line, MAX_ADDR, buffer))
		ProgramSettings.OpenVPNPort = 3478;
	else ProgramSettings.OpenVPNPort = _wtoi(line);

	if(!GetPrivateProfileString(L"settings", L"LocalTunnelIP", NULL, line, MAX_ADDR, buffer))
		strcpy_s(ProgramSettings.LTunIP, 64, "10.4.0.1");
	else wcstombs(ProgramSettings.LTunIP, line, 64);

	if(!GetPrivateProfileString(L"settings", L"UserHandle", NULL, ProgramSettings.UserHandle, MAX_ADDR, buffer))
	{
		ret = -1;
		wcscpy_s(ProgramSettings.UserHandle, 64, L"myusername@myjabberserver.com");
	}

	if(!GetPrivateProfileString(L"settings", L"JabberPassword", NULL, ProgramSettings.Pass, MAX_ADDR, buffer))
	{
		ret = -1;
		wcscpy_s(ProgramSettings.Pass, 64, L"mypass");
	}

	if(!GetPrivateProfileString(L"settings", L"CMDPassword", NULL, ProgramSettings.CMDPass, MAX_ADDR, buffer))
	{
		ret = -1;
		wcscpy_s(ProgramSettings.CMDPass, 64, L"mycmdpass");
	}

	if(!GetPrivateProfileString(L"settings", L"StunAddress", NULL, ProgramSettings.StunAddr, MAX_ADDR, buffer))
		wcscpy_s(ProgramSettings.StunAddr, 64, L"stun.xten.com");

	if(!GetPrivateProfileString(L"settings", L"OpenVPNStartString", NULL, ProgramSettings.OpenVPNStartString, MAX_STRING, buffer))
		wcscpy_s(ProgramSettings.OpenVPNStartString, 1024, L"--dev tun1 --ping 10 --comp-lzo --persist-tun");

	if(GetPrivateProfileString(L"settings", L"DisableSleep", NULL, line, 10, buffer) &&
		(wcscmp(line , L"TRUE") == 0))
		ProgramSettings.DisableSleep = true;
	else ProgramSettings.DisableSleep = false;

	return ret;
}

int WriteSettings()
{
	WCHAR buffer[MAX_PATH];
	WCHAR line[MAX_STRING];
	WCHAR drive[_MAX_DRIVE];
	WCHAR dir[_MAX_DIR];
	WCHAR fname[_MAX_FNAME];
	GetModuleFileName(NULL,buffer,MAX_PATH); 
   _wsplitpath(buffer, drive, dir, fname, NULL);
//   _makepath(ProgramSettings.PathToFiles, drive, dir, NULL, NULL);
   _wmakepath(buffer, drive, dir, fname, L"ini");
	
	switch (ProgramSettings.mode)
	{
		case 0: 
			WritePrivateProfileString(L"settings", L"mode", L"dialog", buffer);
			break;
		case 1:
			WritePrivateProfileString(L"settings", L"mode", L"hidden", buffer);
			break;
		case 2:
			WritePrivateProfileString(L"settings", L"mode", L"service", buffer);
			break;
	}
	_itow_s(ProgramSettings.jabberUpdateTime, line, 10, 10);
	WritePrivateProfileString(L"settings", L"jabberUpdateTime", line, buffer);
	_itow_s(ProgramSettings.OpenVPNPort, line, 10, 10);
	WritePrivateProfileString(L"settings", L"OpenVPNPort", line, buffer);
	WritePrivateProfileString(L"settings", L"UserHandle", ProgramSettings.UserHandle, buffer);
	WritePrivateProfileString(L"settings", L"JabberPassword", ProgramSettings.Pass, buffer);
	WritePrivateProfileString(L"settings", L"CMDPassword", ProgramSettings.CMDPass, buffer);
	WritePrivateProfileString(L"settings", L"StunAddress", ProgramSettings.StunAddr, buffer);
	WritePrivateProfileString(L"settings", L"OpenVPNStartString", ProgramSettings.OpenVPNStartString, buffer);
	mbstowcs(line, ProgramSettings.LTunIP, 64);
	WritePrivateProfileString(L"settings", L"LocalTunnelIP", line, buffer);
	if(ProgramSettings.DisableSleep)
		WritePrivateProfileString(L"settings", L"DisableSleep", L"TRUE", buffer);
	else
		WritePrivateProfileString(L"settings", L"DisableSleep", L"FALSE", buffer);
	return 0;
}